<?php

namespace HCM\FPA\Entity;

use HCM\Util\Repositories;
use HCM\Util\TkEntity;
use Zeedhi\Framework\ORM\DateTime;
use HCM\Util\MsgCalculo;

class FpaassoceventoEntity extends TkEntity
{
    private $_nrOrgPadrao;
    private $_nrorg;

    public function __construct($entityManager, $hcmParameters) {
        $this->hcmParameters = $hcmParameters;
        $this->_nrOrgPadrao = $hcmParameters->getNrorgPadrao();
        $this->_nrorg = $hcmParameters->getNrorgTrabalho();
        
        parent::__construct(null,$entityManager);
    }

    public function inicializaLista($nrorg){
        $tmp = $this->entityManager->getRepository(Repositories::FPA_ASSOCEVENTO)->findBy(array('nrorg' => array($nrorg, $this->_nrOrgPadrao)));
        foreach ($tmp as $tmp_associacao) {
            $this->addItem($tmp_associacao->getNreventom(), $tmp_associacao->getNrtipoassoceve());
        }
    }

    public function retornaEvento($tipo_associacao, $nrorg){
        $itens = $this->getItems();
        if (empty($itens) === true) {
            $this->inicializaLista($nrorg);
        }
        $item = $this->getItem($tipo_associacao);
        if (empty($item) === false) {
            return $item;
        }
        MsgCalculo::getInstance()->adicionaMensagem('Associacao '.$tipo_associacao.' nao encontrada');
    }

    public function retornaEventoAssociado($associacao, FpaeventomEntity $eventom, $nrOrg){
        
        //$nrevento = $this->retornaEvento($associacao, $nrOrg);
        return $eventom->retornaEvento($associacao);
    }

    public function determinaReferenciaEventoAssociado(array $nrAssociacoes, $eventom){
        $eventoAssoc = array();
        foreach ($nrAssociacoes as $nrAssocEvento){
            $evento = $this->retornaEventoAssociado($nrAssocEvento, $eventom, $this->_nrorg);
            if (is_object($evento)){
                $eventoAssoc[$nrAssocEvento] = (int)$evento->historico->getVrpercentualevento();
            }
            else {
                MsgCalculo::getInstance()->adicionaMensagem('Evento não encontrado para associação '.$nrAssocEvento);
            }
        }
        return $eventoAssoc;
    }
    
}