<?php
namespace HCM\PTO\Repository;

use Doctrine\DBAL\Connection;

class GerarLoteEventosRepository {

    protected  $connection;
    public function __construct(Connection $connection) {
        $this->connection = $connection;
    }

    public function getIdmediavalref($nreventom, $dtmescompetencia) {
        $query = "SELECT IDMEDIAVALREF FROM FPA_EVENTOH
                      JOIN FPA_EVENTOM
                        ON FPA_EVENTOM.NREVENTOM = FPA_EVENTOH.NREVENTOM
                     WHERE FPA_EVENTOM.NREVENTOM = $nreventom
                       AND FPA_EVENTOH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC)
                                                           FROM FPA_EVENTOH
                                                          WHERE NREVENTOM       = FPA_EVENTOM.NREVENTOM
                                                            AND DTMESCOMPETENC <= TO_DATE('$dtmescompetencia', 'DD/MM/YYYY'))";

        return $this->connection->fetchAll($query)[0]['IDMEDIAVALREF'];
    }

    public function getResumoPorSelecao($criterio, $inicio, $fim, $dtCompetencia, $nrTipoVinculo, $nrPeriodoApuracao, $dtPeriodoIni, $dtPeriodoFim, $nrOrgPadrao, $nrOrg, $lote = null) {
        /*Caso o início for maior que o fim os dois são invertidos para que a busca seja realizada dentro do intervalo informado*/
        if(($inicio > $fim) and ($criterio != 'NRESTRUTLEGAL')){
            $dsInicio = $fim;
            $dsFim = $inicio;
        }
        else {
            $dsInicio = $inicio;
            $dsFim = $fim;
        }

        /*Verifica se a busca está sendo feita a partir da geração de lote de eventos. Caso 'Sim', só busca os resumos que não possuem lote.*/
        if(is_null($lote)){
            $whereIsLote = '1=1';
        }
        else {
            $whereIsLote = 'RSF.NRLOTELANCEVENTO IS NULL';
        }

        if($criterio == 'NMVINCULOM'  || $criterio == 'DTADMISSAOVINC' ||
           $criterio == 'CDMATRICULA' || $criterio == 'NRESTRUTLEGAL') {
               
            // Caso o criério seja 'NRESTRUTLEGAL' e for passada NRESTRUTGEREN ($fim) a condição do $criterio deve ser anulada na query.
            // Assim, somente os filtros de NRESTRUTLEGAL e NRESTRUGEREN serão utilizados
            if ($criterio === 'NRESTRUTLEGAL' && !empty($fim)) {
                $criterio = -1;
            }
            
            // viniciusmayrink  - 27/05/2021 - Query alterada por motivos de performance. Parametros ainda deverão ser alterados. A query sem criterios (else abaixo) nao foi alterada
            $query = "SELECT RSF.*
                      FROM PTO_RESUMOSITUFREQ RSF
                      JOIN PTO_SITUFREQPARAM SFP
                        ON SFP.NRSITUFREQUENCIA = RSF.NRSITUFREQUENCIA
                       AND (SFP.NRORG = RSF.NRORG OR SFP.NRORG = $nrOrgPadrao)
                      JOIN FPA_EVENTOH EVH
                        ON EVH.NREVENTOM = SFP.NREVENTOM
                       AND (EVH.NRORG = SFP.NRORG OR EVH.NRORG = $nrOrgPadrao)
                       /* FILTROS DE ESTRUTURA PARA A INCIDÊNCIA DO EVENTO OU NÃO */
                       AND EXISTS (SELECT 1
                                   FROM GPE_VINCULOM VCM
                                   INNER JOIN GPE_VINCULOH VCH
                                           ON (VCH.NRVINCULOM = VCM.NRVINCULOM AND  VCH.NRORG = VCM.NRORG)
                                          AND (($criterio BETWEEN '$dsInicio' AND '$dsFim')
                                          OR  (TO_CHAR(VCH.NRESTRUTLEGAL) = '$inicio'
                                          AND ((TO_CHAR(VCH.NRESTRUTGEREN) = '$fim') OR ('$fim' IS NULL))))
                                          AND VCH.DTMESCOMPETENC = (SELECT MAX(VIH.DTMESCOMPETENC)
                                                                      FROM GPE_VINCULOH VIH
                                                                     WHERE VIH.NRVINCULOM  = VCM.NRVINCULOM
                                                                       AND VIH.NRORG = VCM.NRORG
                                                                       AND VIH.DTMESCOMPETENC <= '$dtCompetencia')                                                                                                         
                                  WHERE VCM.NRVINCULOM = RSF.NRVINCULOM
                                    AND VCM.NRORG = RSF.NRORG                       
                                    AND VCM.NRORG = $nrOrg
                                    AND (SFP.NRESTRUTLEGAL  IS NULL OR INSTR(',' || SFP.NRESTRUTLEGAL   || ',', ','     || VCH.NRESTRUTLEGAL || ',') > 0)
                                    AND (SFP.NRESTRUTGEREN  IS NULL OR INSTR(',' || SFP.NRESTRUTGEREN   || ',', ','     || VCH.NRESTRUTGEREN || ',') > 0)
                                    AND (SFP.NRESTRUTSIND   IS NULL OR INSTR(',' || SFP.NRESTRUTSIND    || ',', ','     || VCH.NRESTRUTSIND  || ',') > 0)                                                                
                                    )                                               
                       AND EVH.DTMESCOMPETENC IN (SELECT MAX(EH.DTMESCOMPETENC)
                                                    FROM FPA_EVENTOH EH
                                                   WHERE EH.DTMESCOMPETENC <= '$dtCompetencia'
                                                     AND EH.NREVENTOM = EVH.NREVENTOM
                                                     AND EH.NRORG = EVH.NRORG)                                                                                                
                     WHERE RSF.NRORG = $nrOrg
                       and RSF.NRPERIODOAPURACAO = $nrPeriodoApuracao
                       AND RSF.IDCONFIRMADA = 'S'
                       AND RSF.DTAPURACAOSITUFREQ BETWEEN '$dtPeriodoIni' AND '$dtPeriodoFim'
                       AND $whereIsLote";
            
            // $query = "SELECT RSF.*
            //           FROM PTO_RESUMOSITUFREQ RSF
            //          INNER JOIN (SELECT VCM.NRVINCULOM, VCM.NRORG, VCH.NRESTRUTLEGAL, VCH.NRESTRUTGEREN, VCH.NRESTRUTSIND
            //                       FROM GPE_TIPOVINCULOM TVM, GPE_VINCULOM VCM
            //                  INNER JOIN GPE_VINCULOH VCH
            //                          ON (VCH.NRVINCULOM = VCM.NRVINCULOM AND  VCH.NRORG = VCM.NRORG)
            //                       WHERE (($criterio BETWEEN '$dsInicio' AND '$dsFim')
            //                          OR (TO_CHAR(VCH.NRESTRUTLEGAL) = '$inicio'
            //                         AND ((TO_CHAR(VCH.NRESTRUTGEREN) = '$fim') OR ('$fim' IS NULL))))
            //                         AND VCH.DTMESCOMPETENC IN (SELECT MAX(VIH.DTMESCOMPETENC)
            //                                                      FROM GPE_VINCULOH VIH
            //                                                     WHERE VIH.NRVINCULOM  = VCM.NRVINCULOM
            //                                                       AND VIH.NRORG = VCM.NRORG
            //                                                       AND VIH.DTMESCOMPETENC <= '$dtCompetencia')
            //                         AND VCM.NRTIPOVINCULOM = TVM.NRTIPOVINCULOM
            //                         AND VCM.NRTIPOVINCULOM = $nrTipoVinculo
            //                         AND VCM.NRORG = $nrOrg
            //                         AND (TVM.NRORG = VCM.NRORG OR TVM.NRORG = $nrOrgPadrao)) VIN ON VIN.NRVINCULOM = RSF.NRVINCULOM
            //                                                                                     AND VIN.NRORG = RSF.NRORG
            //           JOIN PTO_SITUFREQPARAM SFP
            //             ON SFP.NRSITUFREQUENCIA = RSF.NRSITUFREQUENCIA
            //           AND (SFP.NRORG = RSF.NRORG OR SFP.NRORG = $nrOrgPadrao)
            //           JOIN FPA_EVENTOH EVH
            //             ON EVH.NREVENTOM = SFP.NREVENTOM
            //           AND (EVH.NRORG = SFP.NRORG OR EVH.NRORG = 0)
            //           /* FILTROS DE ESTRUTURA PARA A INCIDÊNCIA DO EVENTO OU NÃO */
            //           AND (SFP.NRESTRUTLEGAL  IS NULL OR INSTR(',' || SFP.NRESTRUTLEGAL   || ',', ','     || VIN.NRESTRUTLEGAL || ',') > 0)
            //           AND (SFP.NRESTRUTGEREN  IS NULL OR INSTR(',' || SFP.NRESTRUTGEREN   || ',', ','     || VIN.NRESTRUTGEREN || ',') > 0)
            //           AND (SFP.NRESTRUTSIND   IS NULL OR INSTR(',' || SFP.NRESTRUTSIND    || ',', ','     || VIN.NRESTRUTSIND  || ',') > 0)
                       
            //           AND EVH.DTMESCOMPETENC IN (SELECT MAX(EH.DTMESCOMPETENC)
            //                                         FROM FPA_EVENTOH EH
            //                                       WHERE EH.DTMESCOMPETENC <= '$dtCompetencia'
            //                                          AND EH.NREVENTOM = EVH.NREVENTOM
            //                                          AND EH.NRORG = EVH.NRORG)                                                                                                
            //          WHERE RSF.NRPERIODOAPURACAO = $nrPeriodoApuracao
            //           AND RSF.IDCONFIRMADA = 'S'
            //           AND RSF.DTAPURACAOSITUFREQ BETWEEN '$dtPeriodoIni' AND '$dtPeriodoFim'
            //           AND $whereIsLote";
        } else {
            $query = "SELECT RSF.*
                      FROM PTO_RESUMOSITUFREQ RSF
                     INNER JOIN (SELECT VCM.NRVINCULOM, VCM.NRORG, VCH.NRESTRUTLEGAL, VCH.NRESTRUTGEREN, VCH.NRESTRUTSIND
                                   FROM GPE_TIPOVINCULOM TVM, GPE_VINCULOM VCM
                             INNER JOIN GPE_VINCULOH VCH
                                     ON (VCH.NRVINCULOM = VCM.NRVINCULOM AND  VCH.NRORG = VCM.NRORG)
                                  WHERE VCH.DTMESCOMPETENC IN (SELECT MAX(VIH.DTMESCOMPETENC)
                                                                 FROM GPE_VINCULOH VIH
                                                                WHERE VIH.NRVINCULOM  = VCM.NRVINCULOM
                                                                  AND VIH.NRORG = VCM.NRORG
                                                                  AND VIH.DTMESCOMPETENC <= '$dtCompetencia')
                                    AND VCM.NRTIPOVINCULOM = TVM.NRTIPOVINCULOM
                                    AND VCM.NRTIPOVINCULOM = $nrTipoVinculo
                                    AND VCM.NRORG = $nrOrg
                                    AND (TVM.NRORG = VCM.NRORG OR TVM.NRORG = $nrOrgPadrao)) VIN ON VIN.NRVINCULOM = RSF.NRVINCULOM
                                                                                                AND VIN.NRORG = RSF.NRORG
                      JOIN PTO_SITUFREQPARAM SFP
                        ON SFP.NRSITUFREQUENCIA = RSF.NRSITUFREQUENCIA
                       AND (SFP.NRORG = RSF.NRORG OR SFP.NRORG = $nrOrgPadrao)
                       /* FILTROS DE ESTRUTURA PARA A INCIDÊNCIA DO EVENTO OU NÃO */
                       AND (SFP.NRESTRUTLEGAL  IS NULL OR INSTR(',' || SFP.NRESTRUTLEGAL   || ',', ','     || VIN.NRESTRUTLEGAL || ',') > 0)
                       AND (SFP.NRESTRUTGEREN  IS NULL OR INSTR(',' || SFP.NRESTRUTGEREN   || ',', ','     || VIN.NRESTRUTGEREN || ',') > 0)
                       AND (SFP.NRESTRUTSIND   IS NULL OR INSTR(',' || SFP.NRESTRUTSIND    || ',', ','     || VIN.NRESTRUTSIND  || ',') > 0)
                       
                      JOIN FPA_EVENTOH EVH
                        ON EVH.NREVENTOM = SFP.NREVENTOM
                       AND (EVH.NRORG = SFP.NRORG OR EVH.NRORG = 0)
                       AND EVH.DTMESCOMPETENC IN (SELECT MAX(EH.DTMESCOMPETENC)
                                                    FROM FPA_EVENTOH EH
                                                   WHERE EH.DTMESCOMPETENC <= '$dtCompetencia'
                                                     AND EH.NREVENTOM = EVH.NREVENTOM
                                                     AND EH.NRORG = EVH.NRORG)                                                                                                
                     WHERE RSF.NRPERIODOAPURACAO = $nrPeriodoApuracao
                       AND RSF.IDCONFIRMADA = 'S'
                       AND RSF.DTAPURACAOSITUFREQ BETWEEN '$dtPeriodoIni' AND '$dtPeriodoFim'
                       AND $whereIsLote";
        }
        $result = $this->connection->fetchAll($query);
        return (count($result) > 0) ? $result : false;
    }

    public function getResumoParaLote($criterio, $inicio, $fim, $dtCompetencia, $nrTipoVinculo, $nrPeriodoApuracao, $dtPeriodoIni, $dtPeriodoFim, $nrOrgPadrao, $nrOrg) {
        /*Caso o início for maior que o fim os dois são invertidos para que a busca seja realizada dentro do intervalo informado*/
        if(($inicio > $fim) and ($criterio != 'NRESTRUTLEGAL')){
            $dsInicio = $fim;
            $dsFim = $inicio;
        }
        else {
            $dsInicio = $inicio;
            $dsFim = $fim;
        }

        // LEONARDOCARVALHO - 26/11/2015 - CRIADO CASE
        // Case modificado  - 02/12/2020 - Adicionando distinct
        if($criterio == 'NMVINCULOM'  || $criterio == 'DTADMISSAOVINC' ||
            $criterio == 'CDMATRICULA' || $criterio == 'NRESTRUTLEGAL') {
                
            // Caso o criério seja 'NRESTRUTLEGAL' e for passada NRESTRUTGEREN ($fim) a condição do $criterio deve ser anulada na query.
            // Assim, somente os filtros de NRESTRUTLEGAL e NRESTRUGEREN serão utilizados
            if ($criterio === 'NRESTRUTLEGAL' && !empty($fim)) {
                $criterio = -1;
            }
            
            $query = "SELECT RSF.NRVINCULOM,
                           VIN.NMVINCULOM,
                           SFP.NREVENTOM,
                           EVH.NMEVENTOH,
                           EVH.IDMEDIAVALREF,
                           CASE
                             WHEN SFP.NREVENTOM IN (1040, 1690) THEN
                                /*COUNT(RSF.QTREFAPURSITUFREQ)*/
                                COUNT(DISTINCT RSF.DTAPURACAOSITUFREQ)
                              ELSE
                                SUM(RSF.QTREFAPURSITUFREQ)
                           END QTREFAPURSITUFREQ
                      FROM PTO_RESUMOSITUFREQ RSF
                     INNER JOIN (SELECT VCM.NRVINCULOM, VCM.NRORG, VCM.NMVINCULOM, VCH.NRESTRUTLEGAL, VCH.NRESTRUTGEREN, VCH.NRESTRUTSIND
                                   FROM GPE_TIPOVINCULOM TVM, GPE_VINCULOM VCM
                             INNER JOIN GPE_VINCULOH VCH
                                     ON (VCH.NRVINCULOM = VCM.NRVINCULOM AND  VCH.NRORG = VCM.NRORG)
                                  WHERE (($criterio BETWEEN '$dsInicio' AND '$dsFim')
                                     OR (TO_CHAR(VCH.NRESTRUTLEGAL) = '$inicio'
                                    AND ((TO_CHAR(VCH.NRESTRUTGEREN) = '$fim') OR ('$fim' IS NULL))))
                                    AND VCH.DTMESCOMPETENC IN (SELECT MAX(VIH.DTMESCOMPETENC)
                                                                 FROM GPE_VINCULOH VIH
                                                                WHERE VIH.NRVINCULOM  = VCM.NRVINCULOM
                                                                  AND VIH.NRORG = VCM.NRORG
                                                                  AND VIH.DTMESCOMPETENC <= '$dtCompetencia')
                                    AND VCM.NRTIPOVINCULOM = TVM.NRTIPOVINCULOM
                                    AND VCM.NRTIPOVINCULOM = $nrTipoVinculo
                                    AND VCM.NRORG = $nrOrg
                                    AND (TVM.NRORG = VCM.NRORG OR TVM.NRORG = $nrOrgPadrao)) VIN
                        ON VIN.NRVINCULOM = RSF.NRVINCULOM
                       AND VIN.NRORG = RSF.NRORG
                      JOIN PTO_SITUFREQPARAM SFP
                        ON SFP.NRSITUFREQUENCIA = RSF.NRSITUFREQUENCIA
                       AND (SFP.NRORG = RSF.NRORG OR SFP.NRORG = $nrOrgPadrao)
                       /* FILTROS DE ESTRUTURA PARA A INCIDÊNCIA DO EVENTO OU NÃO */
                       AND (SFP.NRESTRUTLEGAL  IS NULL OR INSTR(',' || SFP.NRESTRUTLEGAL   || ',', ','     || VIN.NRESTRUTLEGAL || ',') > 0)
                       AND (SFP.NRESTRUTGEREN  IS NULL OR INSTR(',' || SFP.NRESTRUTGEREN   || ',', ','     || VIN.NRESTRUTGEREN || ',') > 0)
                       AND (SFP.NRESTRUTSIND   IS NULL OR INSTR(',' || SFP.NRESTRUTSIND    || ',', ','     || VIN.NRESTRUTSIND  || ',') > 0)
                       
                      JOIN FPA_EVENTOH EVH
                        ON EVH.NREVENTOM = SFP.NREVENTOM
                       AND (EVH.NRORG = SFP.NRORG OR EVH.NRORG = 0)
                       AND EVH.DTMESCOMPETENC IN (SELECT MAX(EH.DTMESCOMPETENC)
                                                    FROM FPA_EVENTOH EH
                                                   WHERE EH.DTMESCOMPETENC <= '$dtCompetencia'
                                                     AND EH.NREVENTOM = EVH.NREVENTOM
                                                     AND EH.NRORG = EVH.NRORG)
                     WHERE RSF.NRPERIODOAPURACAO = $nrPeriodoApuracao
                       AND RSF.DTAPURACAOSITUFREQ BETWEEN '$dtPeriodoIni' AND '$dtPeriodoFim'
                       AND RSF.IDCONFIRMADA = 'S'
                       AND RSF.NRLOTELANCEVENTO IS NULL
                     GROUP BY RSF.NRVINCULOM, VIN.NMVINCULOM, SFP.NREVENTOM, EVH.NMEVENTOH, EVH.IDMEDIAVALREF
                     ORDER BY VIN.NMVINCULOM, SFP.NREVENTOM";
        } else {
            $query = "SELECT RSF.NRVINCULOM,
                           VIN.NMVINCULOM,
                           SFP.NREVENTOM,
                           EVH.NMEVENTOH,
                           EVH.IDMEDIAVALREF,
                           CASE
                             WHEN SFP.NREVENTOM = 1040 THEN
                                /*COUNT(RSF.QTREFAPURSITUFREQ)*/
                                COUNT(DISTINCT RSF.DTAPURACAOSITUFREQ)
                              ELSE
                                SUM(RSF.QTREFAPURSITUFREQ)
                           END QTREFAPURSITUFREQ
                      FROM PTO_RESUMOSITUFREQ RSF
                     INNER JOIN (SELECT VCM.NRVINCULOM, VCM.NRORG, VCM.NMVINCULOM, VCH.NRESTRUTLEGAL, VCH.NRESTRUTGEREN, VCH.NRESTRUTSIND
                                   FROM GPE_TIPOVINCULOM TVM, GPE_VINCULOM VCM
                             INNER JOIN GPE_VINCULOH VCH
                                     ON (VCH.NRVINCULOM = VCM.NRVINCULOM AND  VCH.NRORG = VCM.NRORG)
                                  WHERE VCH.DTMESCOMPETENC IN (SELECT MAX(VIH.DTMESCOMPETENC)
                                                                 FROM GPE_VINCULOH VIH
                                                                WHERE VIH.NRVINCULOM  = VCM.NRVINCULOM
                                                                  AND VIH.NRORG = VCM.NRORG
                                                                  AND VIH.DTMESCOMPETENC <= '$dtCompetencia')
                                    AND VCM.NRTIPOVINCULOM = TVM.NRTIPOVINCULOM
                                    AND VCM.NRTIPOVINCULOM = $nrTipoVinculo
                                    AND VCM.NRORG = $nrOrg
                                    AND (TVM.NRORG = VCM.NRORG OR TVM.NRORG = $nrOrgPadrao)) VIN
                        ON VIN.NRVINCULOM = RSF.NRVINCULOM
                       AND VIN.NRORG = RSF.NRORG
                      JOIN PTO_SITUFREQPARAM SFP
                        ON SFP.NRSITUFREQUENCIA  = RSF.NRSITUFREQUENCIA
                       AND (SFP.NRORG = RSF.NRORG OR SFP.NRORG = $nrOrgPadrao)
                       /* FILTROS DE ESTRUTURA PARA A INCIDÊNCIA DO EVENTO OU NÃO */
                       AND (SFP.NRESTRUTLEGAL  IS NULL OR INSTR(',' || SFP.NRESTRUTLEGAL   || ',', ','     || VIN.NRESTRUTLEGAL || ',') > 0)
                       AND (SFP.NRESTRUTGEREN  IS NULL OR INSTR(',' || SFP.NRESTRUTGEREN   || ',', ','     || VIN.NRESTRUTGEREN || ',') > 0)
                       AND (SFP.NRESTRUTSIND   IS NULL OR INSTR(',' || SFP.NRESTRUTSIND    || ',', ','     || VIN.NRESTRUTSIND  || ',') > 0)
                       
                      JOIN FPA_EVENTOH EVH
                        ON EVH.NREVENTOM = SFP.NREVENTOM
                       AND (EVH.NRORG = SFP.NRORG OR EVH.NRORG = 0)
                       AND EVH.DTMESCOMPETENC IN (SELECT MAX(EH.DTMESCOMPETENC)
                                                   FROM FPA_EVENTOH EH
                                                  WHERE EH.DTMESCOMPETENC <= '$dtCompetencia'
                                                    AND EH.NREVENTOM = EVH.NREVENTOM
                                                    AND EH.NRORG = EVH.NRORG)
                     WHERE RSF.NRPERIODOAPURACAO = $nrPeriodoApuracao
                       AND RSF.DTAPURACAOSITUFREQ BETWEEN '$dtPeriodoIni' AND '$dtPeriodoFim'
                       AND RSF.IDCONFIRMADA = 'S'
                       AND RSF.NRLOTELANCEVENTO IS NULL
                     GROUP BY RSF.NRVINCULOM, VIN.NMVINCULOM, SFP.NREVENTOM, EVH.NMEVENTOH, EVH.IDMEDIAVALREF
                     ORDER BY VIN.NMVINCULOM, SFP.NREVENTOM";
        }
        $result = $this->connection->fetchAll($query);

        return (count($result) > 0) ? $result : false;
    }

}