<?php
/**
 * Created by JetBrains PhpStorm.
 * User: jorgefonseca
 * Date: 22/10/13
 * Time: 15:09
 * To change this template use File | Settings | File Templates.
 */
namespace Scheduler\Util;

use Setforms2\Runtime\Framework;
use Setforms2\Runtime\Mapper\Crud;
use Setforms2\Shared\Util\Util;

/**
 * Class Macros
 *   Uma coleção de funções úteis, derivadas de Runtime\macros
 * @package Scheduler\Util
 */
class Macros
{
    /**
     * Seta todos os campos com nome em $field_names da tab $tab_name e window $window_name visiveis
     * @param array $field_names
     * @param string $tab_name  Null indica que é o atual
     * @param string $window_name  Null indica que é o atual
     */
    static function tk_set_visible_fields(array $field_names, $tab_name = null, $window_name = null)
    {
        foreach ($field_names as $field_name => $field_value) {
            tk_set_visible_field($field_name, $tab_name, $window_name);
        }
    }

    /**
     * Seta todos os campos com nome em $field_names da tab $tab_name e window $window_name invisiveis
     * @param array $field_names
     * @param string $tab_name  Null indica que é o atual
     * @param string $window_name  Null indica que é o atual
     */
    static function tk_set_invisible_fields(array $field_names, $tab_name = null, $window_name = null)
    {
        foreach ($field_names as $field_name => $field_value) {
            tk_set_invisible_field($field_name, $tab_name, $window_name);
        }
    }

    /**
     * Mesmo que o tk_get_menu_param original, mas checa se o indice está setado antes de retornar
     *  p/ evitar erros de indice indefinido
     * @param $index
     * @return bool
     */
    static function tk_get_menu_param($index)
    {
        $menuParams = Framework::getInstance()->getCurrentMapper()->getMenuParams();
        if (isset($menuParams[$index])){
            return $menuParams[$index];
        }
        else return false;

    }
}


function tk_validate_data($showWarning = false) {
    tk_add_method('callValidateFormData', array($showWarning));
}

/*
function tk_disable_result_set_limit() {
    \Setforms2\Runtime\Framework::getInstance()->getCurrentMapper()->setResultsetLimit(1000000);
}*/