<?php

/**
 * GpeAlteocupacao
 * 
 * This class has been auto-generated by the Doctrine ORM Framework
 * 
 * @package    DbModel
 * @subpackage Model
 * @author     alessandrobartels - 08/03/2012 17:31:39 <development@setforms.com>
 * @version    SVN: $Id: Builder.php 6508 2009-10-14 06:28:49Z jwage $
 */
class GpeAlteocupacao extends DaoGpeAlteocupacao
{

    public static function getUltimaOcupacaoPorDatainicio($nrorg, $nrvinculom, $dtiniocupacao) {
        $db = \Setforms2\Runtime\Connection::getInstance();

        $params = array($nrorg, $nrvinculom, $dtiniocupacao);

        $sql = <<<SQL

SELECT *
  FROM GPE_ALTEOCUPACAO
WHERE NRORG         = ?
  AND NRVINCULOM    = ?
  AND DTINIOCUPACAO = (SELECT MAX(DTINIOCUPACAO)
                         FROM GPE_ALTEOCUPACAO B
                       WHERE B.NRORG       = GPE_ALTEOCUPACAO.NRORG
                         AND B.NRVINCULOM  = GPE_ALTEOCUPACAO.NRVINCULOM
                         AND DTINIOCUPACAO <= TO_DATE(?, 'DD/MM/YYYY'))

SQL;
        $resultado = reset($db->fetchAll($sql, $params));
        return $resultado;
    }


    /**
     * Retorna a ultima alteracao de ocupacao do vinculo conforme mes de competencia.
     * @static
     *
     * @param integer    $nrOrg          Numero da Organizacao.
     * @param TkDateTime $mesCompetencia Mes de competencia.
     * @param integer    $nrVinculo      Numero do vinculo.
     *
     * @return GpeAlteocupacaoEntity | null
     * @author alessandrobartels - 23/07/2012
     */
    public static function retornaUltimaAlteracaoOcupacaoVinculo($nrOrg, $mesCompetencia, $nrVinculo){
        $resultado = self::getObjectsByWhere(
            'NRORG = ?
            AND DTINIOCUPACAO <= ?
            AND NRVINCULOM = ?',

            array($nrOrg, $mesCompetencia, $nrVinculo),

            'DTINIOCUPACAO'
        );
      //  tk_var_dump(count($resultado));
      //  tk_warning($nrOrg.' |  '.$mesCompetencia.' |  '.$nrVinculo);
        return end($resultado);
    }


    /**
     * @param $nrOrg
     * @param $nrVinculo
     * @return array<GpeAlteocupacaoEntity>|null
     * @author brunoborba - 07/03/2013
     */
    public static function retornaAlteracaoOcupacaoVinculo($nrOrg, $nrVinculo){
        $resultado = self::getObjectsByWhere(
            'NRORG = ?
            AND NRVINCULOM = ?',
            array($nrOrg, $nrVinculo)

        );

        return $resultado;
    }

    /**
     * @param $nrorg
     * @param $nrvinculom
     * @param $nrtipoocupacao
     * @param int $nrtpmodalidsal
     * @return \GpeAlteocupacaoEntity
     */
    public static function getUltimaAlteracaoPorTipo($nrorg, $nrvinculom, $nrtipoocupacao, $nrtpmodalidsal = 1) {
        $params = array($nrorg, $nrvinculom, $nrtipoocupacao, $nrorg, $nrvinculom, $nrtipoocupacao, $nrtpmodalidsal);
        $where = <<<SQL
    NRORG          = ?
AND NRVINCULOM     = ?
AND NRTIPOOCUPACAO = ?
AND DTINIOCUPACAO  = (SELECT MAX(DTINIOCUPACAO)
                        FROM \Gpealteocupacao
                       WHERE NRORG          = ?
                         AND NRVINCULOM     = ?
                         AND NRTIPOOCUPACAO = ?
                         AND NRTPMODALIDSAL = ?)
SQL;

        return self::getObjectByWhere($where, $params);
    }

}
